/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#include <avr/pgmspace.h>
#include <avr/version.h>
#include <avr/eeprom.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "hardware/gpio/gpio_in.h"
#include "hardware/gpio/gpio_out.h"

int cmd_gpio( int argc, char ** argv )
{
	int channel;
	
	channel = atoi( argv[ 2 ] );
	if ( !(channel < 8 && channel >= 0) )	
	{
		printf_P( PSTR("Error, %d ist kein gülter Ausgang.\r\n"), channel );
		return( 0 );
	}
	
	if ( !strcmp_P( argv[ 1 ], PSTR("get") ) )
		printf_P( PSTR("GPIO (%d) = %d\r\n"), channel, GPIO_out_state( channel ) );

	if ( !strcmp_P( argv[ 1 ], PSTR("set") ) )
	{
		GPIO_out_set( channel );
		printf_P( PSTR("GPIO (%d) = 1\r\n"), channel );
	}
	
	if ( !strcmp_P( argv[ 1 ], PSTR("clear") ) )
	{
		GPIO_out_clear( channel );
		printf_P( PSTR("GPIO (%d) = 1\r\n"), channel );
	}
}
