/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#include <avr/pgmspace.h>
#include <avr/version.h>
#include <avr/eeprom.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "system/net/arp.h"
#include "system/net/ip.h"
#include "system/net/dns.h"
#include "system/stdout/stdout.h"
#include "system/config/config.h"

#include "config.h"

int cmd_ifconfig( int argc, char ** argv )
{
	unsigned char IP[16];
		
	printf_P( PSTR(	"IP:        %s\r\n") , iptostr ( myIP, IP ) );		
	printf_P( PSTR(	"Netmask:   %s\r\n") , 		iptostr ( Netmask, IP ) );
	printf_P( PSTR(	"Gateway:   %s\r\n") , iptostr ( Gateway, IP ) );
	#ifdef DNS
		printf_P( PSTR(	"DNS:       %s\r\n") , iptostr ( DNSserver, IP ) );
	#endif
	printf_P( PSTR( "\r\nHW-Adr: %02x:%02x:%02x:%02x:%02x:%02x\r\n\r\n"),ENC28J60_MAC0,ENC28J60_MAC1,ENC28J60_MAC2,ENC28J60_MAC3,ENC28J60_MAC4,ENC28J60_MAC5);	
}
